Module SQL_業務系統管理
    '---------------------------工程項目BOM表----------------------------------------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_BOM表控制(群組碼 As String)
        ConnOpen_工程SQL() : SQL1 = "SELECT 流水號, 項目 FROM 工程項目BOM表控制 " & 群組碼 & " ORDER BY 項目" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_合約清單_報價用()
        ConnOpen()
        If PA = "" Then
            SQL1 = "SELECT  合約編號, 客戶名稱, 負責人A, 工程地點, 客戶地址, 工程名稱_中 AS 專案名稱, 工程名稱_英, 我司公司, 負責人B, 我司地址, 
                            工程總價, 第一期比例, 第二期比例, 第三期比例, 第四期比例, 第五期比例, 工期, 逾期_中, 最高扣罰_中, 逾期_英, 
                            最高扣罰_英, 減價, 工程廠區, 頁數, 立約日期, 合約種類, 約號排序, 約號尾序, 約號甲方, 報價說明, 合約停止 AS 停止, 
                            簽回檔圖庫, 報價簽回 AS 簽回, 報價放行 AS 審核通過, 幣別, 折讓比例, 稅前歸零, 稅後歸零, 歸零位數
                FROM        合約控制表
                WHERE       約號甲方 LIKE N'%" & PA46 & "%' " & SQL6 & "
                ORDER BY    約號排序  DESC, 約號尾序, 約號甲方, 合約期數"
        Else
            SQL1 = "SELECT  合約編號, 客戶名稱, 負責人A, 工程地點, 客戶地址, 工程名稱_中 AS 專案名稱, 工程名稱_英, 我司公司, 負責人B, 我司地址, 
                            工程總價, 第一期比例, 第二期比例, 第三期比例, 第四期比例, 第五期比例, 工期, 逾期_中, 最高扣罰_中, 逾期_英, 
                            最高扣罰_英, 減價, 工程廠區, 頁數, 立約日期, 合約種類, 約號排序, 約號尾序, 約號甲方, 報價說明, 合約停止 AS 停止, 
                            簽回檔圖庫, 報價簽回 AS 簽回, 報價放行 AS 審核通過, 幣別, 折讓比例, 稅前歸零, 稅後歸零, 歸零位數
                FROM        合約控制表
                WHERE       (合約編號 LIKE N'%" & PA & "%' OR 客戶名稱 LIKE N'%" & PA & "%' OR 負責人A LIKE N'%" & PA & "%' OR 
                            工程地點 LIKE N'%" & PA & "%' OR 客戶地址 LIKE N'%" & PA & "%' OR 工程名稱_中 LIKE N'%" & PA & "%' OR 
                            工程名稱_英 LIKE N'%" & PA & "%') " & SQL6 & "
                ORDER BY    約號排序  DESC, 約號尾序, 約號甲方, 合約期數"
        End If
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_合約報價明細表()
        ConnOpen()
        SQL1 = "SELECT    合約報價明細表.排序, 合約報價明細表.項目 AS ITEM, 合約報價明細表.內容 AS DESCRIPTION, 
                          合約報價明細表.單位 AS UNIT, 合約報價明細表.報價數量 AS QTY, 合約報價明細表.單價, 
                          合約報價明細表.總價, 合約報價明細表.備註 AS REMARKS, 合約報價明細表.實際數量, 
                          合約報價明細表.工資成本單價, 合約報價明細表.工資成本單價 AS 工資成本後價, 合約報價明細表.工資報價單價, 
                          合約報價明細表.工資成本單價 AS 工資報價後價, 合約報價明細表.材料成本單價, 
                          合約報價明細表.材料成本單價 AS 材料成本後價, 合約報價明細表.材料報價單價, 
                          合約報價明細表.材料成本單價 AS 材料報價後價, 合約報價明細表.材料成本單價 AS 利潤, 合約報價明細表.流水號, 
                          QQQ.A1, QQQ.A2, QQQ.A3, QQQ.A4, QQQ.A5, QQQ.A6, QQQ.A7, QQQ.A8, QQQ.規格庫抬頭指定, QQQ.規格庫編號, 
                          QQQ.品名, 合約報價明細表.料號, QQQ.料號原則, 合約報價明細表.材料係數, 合約報價明細表.不計算 AS 不計, 
                          QQQ.S1, QQQ.S2, QQQ.S3, QQQ.S4, QQQ.S5, QQQ.S6, QQQ.S7, QQQ.S8, 合約報價明細表.預設, 合約報價明細表.D1, 
                          合約報價明細表.D2, 合約報價明細表.D3, 合約報價明細表.D4, 合約報價明細表.D5, 合約報價明細表.D6, 
                          合約報價明細表.D7, 合約報價明細表.D8, QQQ.AA1, QQQ.AA2, QQQ.AA3, QQQ.AA4, QQQ.AA5, QQQ.AA6, QQQ.AA7, 
                          QQQ.AA8, 合約報價明細表.不計算, HX空白圖片.圖片 AS [Add], HX空白圖片.圖片 AS [Save], 
                          HX空白圖片.圖片 AS [Dele], 合約報價明細表.不計算 AS 存檔, 合約報價明細表.地點_中, 合約報價明細表.地點_印, 
                          合約報價明細表.主項_中, 合約報價明細表.主項_印, 合約報價明細表.主名_中, 合約報價明細表.主名_印, 合約報價明細表.項名_中, 
                          合約報價明細表.項名_印, 合約報價明細表.描述_中,合約報價明細表. 描述_印, 合約報價明細表.其他_中, 合約報價明細表.其他_印, 
                          合約報價明細表.層級, 合約報價明細表.工資係數, 合約報價明細表.工資單價
                FROM     (SELECT    物料規格表.A1, 物料規格表.A2, 物料規格表.A3, 物料規格表.A4, 物料規格表.A5, 物料規格表.A6, 
                                    物料規格表.A7, 物料規格表.A8, 物料資訊控制表.規格庫編號, 物料資訊控制表.規格庫抬頭指定, 
                                    物料編碼庫轉語言.品名, 物料規格表.料號, 物料資訊控制表.料號原則, 物料規格表.S1, 物料規格表.S2, 
                                    物料規格表.S3, 物料規格表.S4, 物料規格表.S5, 物料規格表.S6, 物料規格表.S7, 物料規格表.S8, 
                                    規格庫抬頭.A1 AS AA1, 規格庫抬頭.A2 AS AA2, 規格庫抬頭.A3 AS AA3, 規格庫抬頭.A4 AS AA4, 
                                    規格庫抬頭.A5 AS AA5, 規格庫抬頭.A6 AS AA6, 規格庫抬頭.A7 AS AA7, 規格庫抬頭.A8 AS AA8
                           FROM     物料規格表 INNER JOIN
                                    物料資訊控制表 ON 物料規格表.群組碼 = 物料資訊控制表.群組碼 AND 
                                    物料規格表.料號原則 = 物料資訊控制表.料號原則 INNER JOIN
                                    物料編碼庫轉語言 ON 物料規格表.群組碼 = 物料編碼庫轉語言.群組碼 AND 
                                    物料規格表.料號原則 = 物料編碼庫轉語言.料號原則 INNER JOIN
                                    規格庫抬頭 ON 物料資訊控制表.規格庫抬頭指定 = 規格庫抬頭.規格庫抬頭指定 AND 
                                    物料編碼庫轉語言.語言 = 規格庫抬頭.語言
                           WHERE   (物料編碼庫轉語言.語言 LIKE N'" & 系統語言 & "')) AS QQQ LEFT OUTER JOIN
                           HX空白圖片 ON QQQ.A1 = HX空白圖片.選擇 RIGHT OUTER JOIN
                           合約報價明細表 ON QQQ.料號 = 合約報價明細表.料號
                WHERE     (合約報價明細表.合約號碼 LIKE N'" & PA & "')
                ORDER BY   合約報價明細表.排序"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_工程項目BOM_群組碼()
        ConnOpen_工程SQL() : SQL1 = "SELECT 群組碼,中文名稱,印尼文名稱 FROM 工程項目BOM表群組碼  ORDER BY 中文名稱" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_工程項目BOM表_群組設定_清單()
        ConnOpen_工程SQL() : SQL1 = "SELECT 群組碼,中文名稱 ,印尼文名稱 AS  [Group Id.] FROM 工程項目BOM表群組碼  ORDER BY 中文名稱" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_工程項目BOM表_群組設定_讀取最後一筆資料()
        ConnOpen_工程SQL() : SQL1 = "SELECT 群組碼 FROM  工程項目BOM表群組碼 ORDER BY 群組碼 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_工程項目BOM表_群組設定_新增(群組碼 As String, 中文名稱 As String, 印尼文名稱 As String)
        ConnOpen_工程SQL()
        SQL1 = "INSERT INTO 工程項目BOM表群組碼 (群組碼 , 中文名稱, 英文名稱, 印尼文名稱) VALUES (N'" & 群組碼 & "',N'" & 中文名稱 & "',N'',N'" & 印尼文名稱 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_工程項目BOM表_群組設定_刪除(群組碼 As String)
        ConnOpen_工程SQL() : SQL1 = "DELETE FROM 工程項目BOM表群組碼  WHERE 群組碼 LIKE N'" & 群組碼 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_工程項目BOM表_群組設定_存檔(群組碼 As String, 中文名稱 As String, 印尼文名稱 As String)
        ConnOpen_工程SQL() : SQL1 = "UPDATE  工程項目BOM表群組碼 SET 中文名稱=N'" & 中文名稱 & "',印尼文名稱=N'" & 印尼文名稱 & "'  WHERE 群組碼 LIKE N'" & 群組碼 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_BOM表明細()
        ConnOpen_工程SQL()
        SQL1 = "SELECT    工程項目BOM表明細.排序, 工程項目BOM表明細.項1, 工程項目BOM表明細.項2, 工程項目BOM表明細.項3, 工程項目BOM表明細.項4, 工程項目BOM表明細.項5, 工程項目BOM表明細.項6, 
                          工程項目BOM表明細.料號, 工程項目BOM表明細.項目, 工程項目BOM表明細.數量, 工程項目BOM表明細.單位,  
                          工程項目BOM表明細.明細流水, QQQ.A1, QQQ.A2, QQQ.A3, QQQ.A4, QQQ.A5, QQQ.A6, QQQ.A7, QQQ.A8, QQQ.規格庫編號, QQQ.規格庫抬頭指定, QQQ.品名, QQQ.料號原則, QQQ.S1, QQQ.S2, 
                          QQQ.S3, QQQ.S4, QQQ.S5, QQQ.S6, QQQ.S7, QQQ.S8, QQQ.AA1, QQQ.AA2, QQQ.AA3, QQQ.AA4, QQQ.AA5, QQQ.AA6, QQQ.AA7, QQQ.AA8, QQQ.單位 AS 物料單位
                FROM      工程項目BOM表明細 LEFT OUTER JOIN
                         (SELECT  [FH-ERP-SYS].dbo.物料規格表.A1, [FH-ERP-SYS].dbo.物料規格表.A2, [FH-ERP-SYS].dbo.物料規格表.A3, [FH-ERP-SYS].dbo.物料規格表.A4, 
                                  [FH-ERP-SYS].dbo.物料規格表.A5, [FH-ERP-SYS].dbo.物料規格表.A6, [FH-ERP-SYS].dbo.物料規格表.A7, [FH-ERP-SYS].dbo.物料規格表.A8, 
                                  [FH-ERP-SYS].dbo.物料資訊控制表.規格庫編號, [FH-ERP-SYS].dbo.物料資訊控制表.規格庫抬頭指定, 
                                  [FH-ERP-SYS].dbo.物料編碼庫轉語言.品名, [FH-ERP-SYS].dbo.物料規格表.料號, [FH-ERP-SYS].dbo.物料資訊控制表.料號原則, [FH-ERP-SYS].dbo.物料規格表.S1, 
                                  [FH-ERP-SYS].dbo.物料規格表.S2, [FH-ERP-SYS].dbo.物料規格表.S3, [FH-ERP-SYS].dbo.物料規格表.S4, [FH-ERP-SYS].dbo.物料規格表.S5, 
                                  [FH-ERP-SYS].dbo.物料規格表.S6, [FH-ERP-SYS].dbo.物料規格表.S7, [FH-ERP-SYS].dbo.物料規格表.S8, [FH-ERP-SYS].dbo.規格庫抬頭.A1 AS AA1, 
                                  [FH-ERP-SYS].dbo.規格庫抬頭.A2 AS AA2, [FH-ERP-SYS].dbo.規格庫抬頭.A3 AS AA3, [FH-ERP-SYS].dbo.規格庫抬頭.A4 AS AA4, [FH-ERP-SYS].dbo.規格庫抬頭.A5 AS AA5, 
                                  [FH-ERP-SYS].dbo.規格庫抬頭.A6 AS AA6, [FH-ERP-SYS].dbo.規格庫抬頭.A7 AS AA7, [FH-ERP-SYS].dbo.規格庫抬頭.A8 AS AA8, [FH-ERP-SYS].dbo.物料編碼庫.單位
                          FROM    [FH-ERP-SYS].dbo.物料規格表 INNER JOIN [FH-ERP-SYS].dbo.物料資訊控制表 ON [FH-ERP-SYS].dbo.物料規格表.群組碼 = [FH-ERP-SYS].dbo.物料資訊控制表.群組碼 AND 
                                  [FH-ERP-SYS].dbo.物料規格表.料號原則 = [FH-ERP-SYS].dbo.物料資訊控制表.料號原則 INNER JOIN [FH-ERP-SYS].dbo.物料編碼庫轉語言 ON 
                                  [FH-ERP-SYS].dbo.物料規格表.群組碼 = [FH-ERP-SYS].dbo.物料編碼庫轉語言.群組碼 AND 
                                  [FH-ERP-SYS].dbo.物料規格表.料號原則 = [FH-ERP-SYS].dbo.物料編碼庫轉語言.料號原則 INNER JOIN
                                  [FH-ERP-SYS].dbo.規格庫抬頭 ON [FH-ERP-SYS].dbo.物料資訊控制表.規格庫抬頭指定 = [FH-ERP-SYS].dbo.規格庫抬頭.規格庫抬頭指定 AND
                                  [FH-ERP-SYS].dbo.物料編碼庫轉語言.語言 = [FH-ERP-SYS].dbo.規格庫抬頭.語言 INNER JOIN [FH-ERP-SYS].dbo.物料編碼庫 ON 
                                  [FH-ERP-SYS].dbo.物料規格表.群組碼 = [FH-ERP-SYS].dbo.物料編碼庫.群組碼 AND [FH-ERP-SYS].dbo.物料規格表.料號原則 = [FH-ERP-SYS].dbo.物料編碼庫.料號原則
                          WHERE   ([FH-ERP-SYS].dbo.物料編碼庫轉語言.語言 LIKE N'" & 系統語言 & "')) AS QQQ ON 工程項目BOM表明細.料號 = QQQ.料號
                WHERE     工程項目BOM表明細.流水號 LIKE '" & PA & "'
                ORDER BY  工程項目BOM表明細.項1, 工程項目BOM表明細.項2, 工程項目BOM表明細.項3, 工程項目BOM表明細.項4, 工程項目BOM表明細.項5, 工程項目BOM表明細.項6"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL合約條件讀取()
        ConnOpen() : SQL1 = "SELECT 約號甲方 FROM 合約控制表 WHERE 約號甲方 NOT LIKE 'GCM' GROUP BY 約號甲方 ORDER BY 約號甲方" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_建築物料請購單申請_物料規格讀取()
        ConnOpen()
        SQL1 = "SELECT  物料編碼庫.原則說明 AS 品名, 物料資訊控制表.群組碼, 物料資訊控制表.料號原則, 物料資訊控制表.規格庫編號, 物料資訊控制表.規格庫抬頭指定
                FROM    物料資訊控制表 INNER JOIN 物料編碼庫 ON 物料資訊控制表.群組碼 = 物料編碼庫.群組碼 AND 物料資訊控制表.料號原則 = 物料編碼庫.料號原則
                WHERE  (物料資訊控制表.料號原則 LIKE N'" & PA & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料規格_SQLB03()
        ConnOpen()
        SQL1 = "SELECT 物料規格表.群組碼, 物料規格表.料號原則, 物料規格表.料號 AS No, 物料規格表.圖檔編號, 物料規格表.A1 AS [" & AAA1 & "], 物料規格表.A2 AS [" & AAA2 & "], 
                               物料規格表.A3 AS [" & AAA3 & "], 物料規格表.A4, 物料規格表.A5, 物料規格表.A6, 物料規格表.A7, 物料規格表.A8, HX選擇按鈕.選擇 AS Pilih, 
                               物料編碼庫.原則說明, 物料規格表.最低庫存量 AS [申請數 Terapkan], 物料規格表.料號 AS Nomor_Bagian
                FROM 物料規格表 LEFT OUTER JOIN 物料編碼庫 ON 物料規格表.群組碼 = 物料編碼庫.群組碼 AND 物料規格表.料號原則 = 物料編碼庫.料號原則 LEFT OUTER JOIN
                             HX選擇按鈕 ON 物料規格表.群組碼 = HX選擇按鈕.對應
                WHERE (物料規格表.料號原則 LIKE N'" & PA & "') AND (物料規格表.群組碼 LIKE N'" & PA4 & "')
                ORDER BY 物料規格表.排序, 物料規格表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料規格_SQLB04()
        ConnOpen()
        SQL1 = "SELECT 物料規格表.群組碼, 物料規格表.料號原則, 物料規格表.料號 AS No, 物料規格表.圖檔編號, 物料規格表.A1 AS [" & AAA1 & "], 物料規格表.A2 AS [" & AAA2 & "], 
                               物料規格表.A3 AS [" & AAA3 & "], 物料規格表.A4 AS [" & AAA4 & "], 物料規格表.A5, 物料規格表.A6, 物料規格表.A7, 物料規格表.A8, HX選擇按鈕.選擇 AS Pilih, 
                               物料編碼庫.原則說明, 物料規格表.最低庫存量 AS [申請數 Terapkan], 物料規格表.料號 AS Nomor_Bagian
                FROM 物料規格表 LEFT OUTER JOIN 物料編碼庫 ON 物料規格表.群組碼 = 物料編碼庫.群組碼 AND 物料規格表.料號原則 = 物料編碼庫.料號原則 LEFT OUTER JOIN
                             HX選擇按鈕 ON 物料規格表.群組碼 = HX選擇按鈕.對應
                WHERE (物料規格表.料號原則 LIKE N'" & PA & "') AND (物料規格表.群組碼 LIKE N'" & PA4 & "')
                ORDER BY 物料規格表.排序, 物料規格表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料規格_SQLB05()
        ConnOpen()
        SQL1 = "SELECT 物料規格表.群組碼, 物料規格表.料號原則, 物料規格表.料號 AS No, 物料規格表.圖檔編號, 物料規格表.A1 AS [" & AAA1 & "], 物料規格表.A2 AS [" & AAA2 & "], 
                               物料規格表.A3 AS [" & AAA3 & "], 物料規格表.A4 AS [" & AAA4 & "], 物料規格表.A5 AS [" & AAA5 & "], 物料規格表.A6, 物料規格表.A7, 物料規格表.A8, 
                               HX選擇按鈕.選擇 AS Pilih, 物料編碼庫.原則說明, 物料規格表.最低庫存量 AS [申請數 Terapkan], 物料規格表.料號 AS Nomor_Bagian
                        FROM 物料規格表 LEFT OUTER JOIN 物料編碼庫 ON 物料規格表.群組碼 = 物料編碼庫.群組碼 AND 物料規格表.料號原則 = 物料編碼庫.料號原則 LEFT OUTER JOIN
                             HX選擇按鈕 ON 物料規格表.群組碼 = HX選擇按鈕.對應
                        WHERE (物料規格表.料號原則 LIKE N'" & PA & "') AND (物料規格表.群組碼 LIKE N'" & PA4 & "') 
                ORDER BY 物料規格表.排序, 物料規格表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料規格_SQLB06()
        ConnOpen()
        SQL1 = "SELECT 物料規格表.群組碼, 物料規格表.料號原則, 物料規格表.料號 AS No, 物料規格表.圖檔編號, 物料規格表.A1 AS [" & AAA1 & "], 物料規格表.A2 AS [" & AAA2 & "], 
                               物料規格表.A3 AS [" & AAA3 & "], 物料規格表.A4 AS [" & AAA4 & "], 物料規格表.A5 AS [" & AAA5 & "], 物料規格表.A6 AS [" & AAA6 & "], 物料規格表.A7, 物料規格表.A8, 
                               HX選擇按鈕.選擇 AS Pilih, 物料編碼庫.原則說明, 物料規格表.最低庫存量 AS [申請數 Terapkan], 物料規格表.料號 AS Nomor_Bagian
                        FROM 物料規格表 LEFT OUTER JOIN 物料編碼庫 ON 物料規格表.群組碼 = 物料編碼庫.群組碼 AND 物料規格表.料號原則 = 物料編碼庫.料號原則 LEFT OUTER JOIN
                             HX選擇按鈕 ON 物料規格表.群組碼 = HX選擇按鈕.對應
                        WHERE (物料規格表.料號原則 LIKE N'" & PA & "') AND (物料規格表.群組碼 LIKE N'" & PA4 & "') 
                ORDER BY 物料規格表.排序, 物料規格表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料規格_SQLB07()
        ConnOpen()
        SQL1 = "SELECT 物料規格表.群組碼, 物料規格表.料號原則, 物料規格表.料號 AS No, 物料規格表.圖檔編號, 物料規格表.A1 AS [" & AAA1 & "], 物料規格表.A2 AS [" & AAA2 & "], 
                               物料規格表.A3 AS [" & AAA3 & "], 物料規格表.A4 AS [" & AAA4 & "], 物料規格表.A5 AS [" & AAA5 & "], 物料規格表.A6 AS [" & AAA6 & "], 物料規格表.A7 AS [" & AAA7 & "], 
                               物料規格表.A8, HX選擇按鈕.選擇 AS Pilih, 物料編碼庫.原則說明, 物料規格表.最低庫存量 AS [申請數 Terapkan], 物料規格表.料號 AS Nomor_Bagian
                        FROM 物料規格表 LEFT OUTER JOIN 物料編碼庫 ON 物料規格表.群組碼 = 物料編碼庫.群組碼 AND 物料規格表.料號原則 = 物料編碼庫.料號原則 LEFT OUTER JOIN
                             HX選擇按鈕 ON 物料規格表.群組碼 = HX選擇按鈕.對應
                        WHERE (物料規格表.料號原則 LIKE N'" & PA & "') AND (物料規格表.群組碼 LIKE N'" & PA4 & "') 
                ORDER BY 物料規格表.排序, 物料規格表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料規格_SQLB08()
        ConnOpen()
        SQL1 = "SELECT 物料規格表.群組碼, 物料規格表.料號原則, 物料規格表.料號 AS No, 物料規格表.圖檔編號, 物料規格表.A1 AS [" & AAA1 & "], 物料規格表.A2 AS [" & AAA2 & "], 
                               物料規格表.A3 AS [" & AAA3 & "], 物料規格表.A4 AS [" & AAA4 & "], 物料規格表.A5 AS [" & AAA5 & "], 物料規格表.A6 AS [" & AAA6 & "], 物料規格表.A7 AS [" & AAA7 & "], 
                               物料規格表.A8 AS [" & AAA8 & "], HX選擇按鈕.選擇 AS Pilih, 物料編碼庫.原則說明, 物料規格表.最低庫存量 AS [申請數 Terapkan], 物料規格表.料號 AS Nomor_Bagian
                        FROM 物料規格表 LEFT OUTER JOIN 物料編碼庫 ON 物料規格表.群組碼 = 物料編碼庫.群組碼 AND 物料規格表.料號原則 = 物料編碼庫.料號原則 LEFT OUTER JOIN
                             HX選擇按鈕 ON 物料規格表.群組碼 = HX選擇按鈕.對應
                        WHERE (物料規格表.料號原則 LIKE N'" & PA & "') AND (物料規格表.群組碼 LIKE N'" & PA4 & "') 
                ORDER BY 物料規格表.排序, 物料規格表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料圖庫_圖檔讀取一()
        ConnOpen() : SQL1 = "SELECT 圖檔 FROM 物料圖庫 WHERE 料號原則 LIKE N'" & PA2 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_合約試算分表_物料清單一()
        If 低網速模式 = False Then : 低網 = ", 物料圖庫.圖檔" : Else : 低網 = "" : End If
        SQL1 = "SELECT 物料編碼庫.群組碼 AS No, 物料編碼庫.料號原則, 物料編碼庫轉語言.品名, 物料編碼庫.群組碼, 物料編碼庫.單位 " & 低網 & "
                FROM   物料編碼庫 INNER JOIN 物料圖庫 ON 物料編碼庫.群組碼 = 物料圖庫.群組碼 AND 物料編碼庫.料號原則 = 物料圖庫.料號原則 INNER JOIN
                           物料編碼庫轉語言 ON 物料編碼庫.料號原則 = 物料編碼庫轉語言.料號原則 AND 物料編碼庫.群組碼 = 物料編碼庫轉語言.群組碼
                WHERE  (物料編碼庫.群組碼 LIKE N'" & PA1 & "%') AND (物料編碼庫轉語言.語言 LIKE N'" & 系統語言 & "')
                ORDER BY   品名, 料號原則"
    End Sub
    Friend Sub SQL_建築物料請購單申請_物料清單三()
        If 低網速模式 = False Then : 低網 = ", 物料圖庫.圖檔" : Else : 低網 = "" : End If
        If 精準 = False Then
            SQL2 = "WHERE    (物料編碼庫.原則說明 LIKE N'%" & PA1 & "%') OR (物料規格表.A1 LIKE N'%" & PA1 & "%') OR (物料規格表.A2 LIKE N'%" & PA1 & "%') OR
                             (物料規格表.A3 LIKE N'%" & PA1 & "%') OR (物料規格表.A4 LIKE N'%" & PA1 & "%') OR (物料規格表.A5 LIKE N'%" & PA1 & "%') OR
                             (物料規格表.A6 LIKE N'%" & PA1 & "%') OR (物料規格表.A7 LIKE N'%" & PA1 & "%') OR (物料規格表.A8 LIKE N'%" & PA1 & "%') OR 
                             (物料編碼庫.料號原則 LIKE N'" & PA1 & "%')"
        Else : SQL2 = "WHERE    (物料編碼庫.料號原則 LIKE N'" & PA1 & "%')" : End If
        SQL1 = "SELECT    QQ.項次 AS No, QQ.料號原則, QQ.原則說明 AS 品名, QQ.群組碼, QQ.單位 " & 低網 & "
                FROM      物料圖庫 RIGHT OUTER JOIN
                         (SELECT    物料編碼庫.群組碼 AS 項次, 物料編碼庫.料號原則, 物料編碼庫.原則說明, 物料編碼庫.單位, HX選擇按鈕.選擇, 物料編碼庫.群組碼, 
                                    HX選擇按鈕.選擇 AS 存檔, 物料資訊控制表.規格庫編號, 物料資訊控制表.規格庫抬頭指定
                          FROM      物料編碼庫 LEFT OUTER JOIN 物料規格表 ON 物料編碼庫.群組碼 = 物料規格表.群組碼 AND 物料編碼庫.料號原則 = 物料規格表.料號原則 LEFT OUTER JOIN
                                    物料資訊控制表 ON 物料編碼庫.群組碼 = 物料資訊控制表.群組碼 AND 物料編碼庫.料號原則 = 物料資訊控制表.料號原則 LEFT OUTER JOIN
                                    HX選擇按鈕 ON 物料編碼庫.群組碼 = HX選擇按鈕.對應 " & SQL2 & "
                          GROUP BY  物料編碼庫.群組碼, 物料編碼庫.料號原則, 物料編碼庫.原則說明, 物料編碼庫.單位, HX選擇按鈕.選擇, 物料編碼庫.群組碼, HX選擇按鈕.選擇, 
                                    物料資訊控制表.規格庫編號, 物料資訊控制表.規格庫抬頭指定) AS QQ ON 物料圖庫.料號原則 = QQ.料號原則 AND 物料圖庫.群組碼 = QQ.群組碼
                          ORDER BY  QQ.料號原則"
    End Sub
    Friend Sub SQL_BOM表控制_項目查詢()
        ConnOpen_工程SQL() : SQL1 = "SELECT 流水號, 項目 FROM 工程項目BOM表控制 WHERE 項目 LIKE N'" & PA1 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_BOM表控制流水號查詢()
        ConnOpen_工程SQL() : SQL1 = "SELECT 流水號 FROM 工程項目BOM表控制 ORDER BY 流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_BOM表控制_新增()
        ConnOpen_工程SQL() : SQL1 = "INSERT INTO 工程項目BOM表控制 (流水號, 項目,群組碼) VALUES (N'" & PA & "', N'" & PA1 & "', N'" & PA40 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_BOM表控制_存檔()
        ConnOpen_工程SQL() : SQL1 = "UPDATE 工程項目BOM表控制 SET 項目 = N'" & PA1 & "'  WHERE 流水號 LIKE N'" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_BOM表控制_刪除()
        ConnOpen_工程SQL() : SQL1 = "DELETE 工程項目BOM表控制 WHERE 流水號 LIKE N'" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_BOM表明細流水號查詢1()
        ConnOpen_工程SQL() : SQL1 = "SELECT 明細流水 FROM 工程項目BOM表明細 ORDER BY 明細流水 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_BOM表明細流水號查詢()
        ConnOpen_工程SQL() : SQL1 = "SELECT 排序 FROM 工程項目BOM表明細 WHERE 流水號 LIKE N'" & PA & "' ORDER BY 排序 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_BOM表明細_新增()
        ConnOpen_工程SQL()
        SQL1 = "INSERT INTO 工程項目BOM表明細 (流水號, 排序, 項目, 料號, 數量, 單位, 明細流水, 項1, 項2, 項3, 項4, 項5, 項6) 
                VALUES (N'" & PA & "', N'" & PA6 & "', N'" & PA2 & "', N'" & PA3 & "', N'" & PA4 & "', N'" & PA5 & "', N'" & PA7 & "', 
                        N'" & PA8 & "', N'" & PA9 & "', N'" & PA10 & "', N'" & PA11 & "', N'" & PA12 & "', N'" & PA13 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_BOM表明細_刪除_全部()
        ConnOpen_工程SQL() : SQL1 = "DELETE 工程項目BOM表明細 WHERE 流水號 LIKE '" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_BOM表明細_刪除()
        ConnOpen_工程SQL() : SQL1 = "DELETE 工程項目BOM表明細 WHERE 明細流水 LIKE '" & PA7 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_工程項目BOM_群組碼_查詢()
        ConnOpen_工程SQL() : SQL1 = "SELECT 群組碼 FROM 工程項目BOM表群組碼 WHERE 中文名稱 LIKE '" & PA40 & "'  ORDER BY 群組碼" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_BOM表明細_存檔()
        ConnOpen_工程SQL()
        SQL1 = "UPDATE 工程項目BOM表明細 SET 排序 = N'" & PA1 & "', 項目 = N'" & PA2 & "', 料號 = N'" & PA3 & "', 數量 = N'" & PA4 & "', 單位 = N'" & PA5 & "' , 
                                             項1 = N'" & PA8 & "', 項2 = N'" & PA9 & "', 項3 = N'" & PA10 & "', 項4 = N'" & PA11 & "', 項5 = N'" & PA12 & "', 項6 = N'" & PA13 & "'
                WHERE 明細流水 LIKE N'" & PA7 & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_BOM表明細_存檔_料號()
        ConnOpen_工程SQL() : SQL1 = "UPDATE 工程項目BOM表明細 SET 料號 = N'" & PA3 & "' WHERE 明細流水 LIKE N'" & PA7 & "'" : CmdSet_For_dr()
    End Sub
End Module
